
# Inleiding 

DigiDemoBord is een digitaal demonstratie-bord voor schaken. Het kan gebruikt worden om schaakstellingen te laten zien, en ook om pijlen en cirkels op het schaakbord te tekenen. Stellingen en zetten kunnen ook van te voren worden ingevoerd en opgeslagen, om later geladen en gebruikt te worden, of partijen kunnen gelezen worden uit een PGN bestand. Deze handleiding hoort bij versie 1.5.2 van het DigiDemoBord.

In deze handleiding wordt eerst de installatie en het eerste gebruik besproken, vervolgens volgt informatie over het presentatiescherm, daarna informatie over het schaakbord zelf, en daarna over het editorscherm (en het maken van eigen stellingen en zettenreeksen). Daarna komt nog een hoofdstuk met opmerkingen over speciale functies van DigiDemoBord.

Als je het DigiDemoBord voor het eerst gebruikt, kan je het beste het volgende lezen tot en met 'Voor je begint', en dan het DigiDemoBord gaan gebruiken. Na gebruik kan je 'Handig om te weten' lezen.

## Installatie van het DigiDemoBord 

Pak het zip-bestand uit. Het zip-bestand bevat de volgende onderdelen:

-   digidemobord.html: het DigiDemoBord;
-   digidemobord-handleiding.pdf: de handleiding voor het DigiDemoBord in pdf-formaat;
-   digidemobord-handleiding.html: de handleiding voor het DigiDemoBord in html-formaat;
-   zetten: een map met voorbeeldbestanden met stellingen en zetten-reeksen.

Voor de installatie is verder niets nodig, de uitgepakte versie van de zip-file (en een werkende web-browser) is voldoende om het DigiDemoBord te gebruiken.

Verwijderen van het DigiDemoBord van je computer kan eenvoudig door de zip-file en de uitgepakte bestanden weer te verwijderen. Er hoeft geen de-installatie programma uitgevoerd te worden, en er blijft verder niets achter op de computer als de bestanden zijn verwijderd.

## Starten van het DigiDemoBord 

Het DigiDemoBord werkt via een internet browser. Het is met name ontwikkeld met Firefox en Chrome, en ook enigzins getest met Edge (Internet Explorer werkt niet goed). Volg de volgende stappen (voor Windows, Linux / MacOS is analoog) om het te gebruiken:

-   zorg dat een bruikbare internet browser (Firefox) geïnstalleerd is (een werkende internet-verbinding is *niet* nodig voor het gebruik van het DigiDemoBord)
-   open digidemobord.html, op een van de volgende manieren:
    -   start de internet browser, en doe dan 'Open Bestand' (bijv. bij Firefox vanuit het menu rechtsboven), en ga dan naar digidemobord.html, of
    -   open een Verkenner, ga naar het bestand digidemobord.html, klik met de rechtermuisknop op dit bestand, en selecteer "Openen met...", en kies dan de juiste internet browser (bijv. Firefox), of
    -   open een Verkenner, ga naar het bestand digidemobord.html, en dubbelklik dit bestand
-   gebruik eventueel de F11 toets om naar volledig scherm te gaan (zie ook [Gebruik je browser](#gebruik-je-browser))

Het DigiDemoBord gebruikt Javascript, de internet browser zou toestemming kunnen vragen om Javascript te gebruiken. Sta dit toe voor dit bestand.

Probeer het DigiDemoBord te starten, en ga dan verder met het volgende hoofdstuk.

## Voor je begint 

Het DigiDemoBord zou zonder veel hulp te gebruiken moeten zijn. Voor het gebruik is het wel goed om het volgende te weten:

-   het DigiDemoBord heeft een presentatiescherm (zie fig. [1](#fig:start), met een groot schaakbord, en wat knoppen rechts ervan), en een editorscherm (met ook allerlei knoppen onder het schaakbord). De editor mode is alleen bedoeld om om nieuwe stellingen in te voeren);
-   de meeste knoppen en velden van het DigiDemoBord hebben een 'tooltip'; dit betekent dat als je de muis naar een knop of veld gaat, er een korte tekst verschijnt met informatie over deze knop of dit element;
-   als je (Ctrl+) H of (Ctrl+) ? indrukt als je met de muis op een knop of element staat, zal de hulp uit deze handleiding in een nieuw window van de browser verschijnen, met de informatie over de knop bovenaan in het scherm;
-   een aantal knoppen, om bijv. te wisselen naar volledig scherm, of om het bord om te draaien, zijn in het presentatiescherm niet zichtbaar. Als je met je muis naar de onderkant van het scherm gaat, wordt de balk met deze knoppen zichtbaar. Deze balk verdwijnt weer automatisch als de muis uit deze balk verdwijnt. In het presentatiescherm kan je deze balk ook via een dubbelklik zichtbaar maken (en weer laten verdwijnen).

# Presentatiescherm 

Fig. [1](#fig:start) laat zien hoe het DigiDemoBord eruit ziet na het opstarten. Je ziet dan het presentatiescherm: het schaakbord en een paar knoppen rechts ervan.

![Figure 1: Presentatiescherm na opstarten.]({{site.baseurl}}/assets/ddb/screenshots//1.5/start-framed.gif){: #fig:start .align-center width="80%"}

DigiDemoBord kan nu gebruikt worden: je kan een stellingen maken door stukken te verslepen (op het bord, van de kant naar het bord, of van het bord af), en je kan ook tekenen op het bord (pijlen en cirkels).

Het presentatiescherm heeft een schaakbord, knoppen rechts ervan, en rechtsboven informatie over een ingelezen bestand. De bovenste rij knoppen (naast het lege schaakbord) is voor het maken van de beginopstelling, en het leeg maken van het bord. De rij knoppen eronder (naast de muispijl) is om aan te geven wat de linkermuisknop moet doen: stukken verplaatsen, of tekenen op het bord. De onderste rij knoppen (naast de blauwe cirkel) gaan over de tekeningen: de linkse knop is voor het verwijderen van de tekeningen, en de andere knop is om de tekeningen zichtbaar te maken, of te verbergen.

## Laden van een bestand 

Je kan een bestand met partijen en/of stellingen laden. In de zip-file (en op de digidemobord website) staat een voorbeeld PGN bestand met een partij van [Fischer en Byrne](https://www.chessgames.com/perl/chessgame?gid=1008419), en een tweetal varianten van de [Saveedra stelling](https://www.schaaksite.nl/2010/12/03/eindspelstudie-11-saveedra/). Je kan dit bestand openen in het DigiDemoBord:

-   klik op het 'Open bestand' icoontje wat rechtsboven het schaakbord staat
-   selecteer met de explorer 'byrne-fischer-saavedra.pgn', en open dit bestand

Het bestand wordt nu geladen, Fig. [2](#fig:start-file) laat zien hoe het presentatiescherm er uit ziet na het laden van een bestand. De naam van het geladen bestand staat rechts bovenin, achter het 'Open bestand' icoon.

Behalve pgn-bestanden kan je ook de tekst (.txt) bestanden laden die met het DigiDemoBord gemaakt zijn, zie hiervoor de informatie over het editorscherm.

![Figure 2: Presentatiescherm na laden van een bestand.]({{site.baseurl}}/assets/ddb/screenshots//1.5/start-file-framed.gif){: #fig:start-file .align-center width="80%"}

Na het laden van een bestand ziet het scherm er iets anders uit. Allereerst is de eerste stelling (partij) uit het bestand automatisch geselecteerd. Daarom zie je nu de beginopstelling, want de eerste stelling is de partij Byrne--Fischer, en die begint met de startopstelling. Verder is het user interface ook veranderd: linksboven staat nu een beschrijving (naam) van een van de stellingen/partijen die geladen is, en rechts, naast het bord, zijn er meer knoppen bijgekomen. De linkse kolom met knoppen is om te bladeren door de stellingen/partijen, en de rechtse kolom is om door de zetten heen te lopen.

De knoppen met pijlen omhoog gaan terug (twee pijlen is helemaal naar het begin, een pijl is een stap terug), en de pijlen naar beneden gaan vooruit. De middelste knop van de linker kolom (voor de stellingen) gaat terug naar de beginstand van de stelling, en de middelste knop van de rechter kolom (voor de zetten) gaat terug naar de stand na de laatste gespeelde zet (dus bijv. als je zelf nog stukken handmatig hebt verplaatst na de vorige zet). Deze knoppen worden hieronder verder uitgelegd.

## Knoppenbalk 

Het DigiDemoBord heeft nog meer opties, en die worden zichtbaar als je met de muis naar de onderkant van het scherm gaat, of als je dubbel klikt op een lege plek. Dan wordt een knoppenbalk zichtbaar, zoals afgebeeld in Fig. [3](#fig:bottom-bar).

![Figure 3: Knoppenbalk die verschijnt als je met de muis naar de onderkant van het scherm gaat.]({{site.baseurl}}/assets/ddb/screenshots//1.5/bottom-bar.gif){: #fig:bottom-bar .align-center width="80%"}

Deze knoppen zijn (voor rechts naar links):

![volledige scherm]({{site.baseurl}}/assets/ddb/screenshots//1.5/full-screen-icon.gif){: #fig:full-screen width="4%"} ![verlaat volledige scherm]({{site.baseurl}}/assets/ddb/screenshots//1.5/exit-full-screen-icon.gif){: #fig:exit-full-screen width="4%"} het gaan naar volledig scherm (linkse icon) en verlaten van volledig scherm (rechtse icon),

![help]({{site.baseurl}}/assets/ddb/screenshots//1.5/help-icon.gif){: #fig:help width="4%"} het laten zien van dit help bestand,

![flip]({{site.baseurl}}/assets/ddb/screenshots//1.5/flip-icon.gif){: #fig:flip width="4%"} het omdraaien van het bord (zwart onder en wit boven, of andersom),

![camera]({{site.baseurl}}/assets/ddb/screenshots//1.5/camera-icon.gif){: #fig:camera width="4%"} het maken van een plaatje van het huidige bord; het plaatje wordt daarna gedownload (en opgeslagen op de computer, afhankelijk van de instellingen van de browser wordt de mogelijkheid gegeven het plaatje te bekijken, of hett bestand een naam te geven),

![editor]({{site.baseurl}}/assets/ddb/screenshots//1.5/editor-icon.gif){: #fig:editor width="4%"} ![presentation]({{site.baseurl}}/assets/ddb/screenshots//1.5/presentation-icon.gif){: #fig:presentation width="4%"} het gaan naar het editorscherm (linkse icon) en het presentatiescherm (rechtse icon).

Het editorscherm wordt verderop beschreven.

## Knoppen naast het schaakbord: bord, muis en cirkels en pijlen

Rechtsboven naast het schaakbord zijn drie rijen met knoppen. Deze rijen zijn achtereenvolgens voor het bord, voor de muisinstelling, en voor de cirkels en pijlen die op het bord getekend zijn.

### Knoppen voor het bord 

![Knoppen voor het bord]({{site.baseurl}}/assets/ddb/screenshots//1.5/board-buttons.gif){: #fig:board-buttons width="12%"} Rechts van het kleine (lege) schaakbord zijn twee knoppen: de linkse (met vier zwarte stukken) zet de startopstelling op het bord, en de rechtse (met vier lege velden) maakt het bord leeg.

### Knoppen voor de muis 

![Knoppen voor de muis]({{site.baseurl}}/assets/ddb/screenshots//1.5/mouse-buttons.gif){: #fig:mouse-buttons width="12%"} Rechts van de zwarte pijl (muiscursor) zijn ook twee knoppen. Die zijn om aan te geven wat je met de linkermuisknop kan doen. Als de linkse button (met zwarte pion) 'aan' staat kan de linkermuisknop gebruikt worden voor het verplaatsen van stukken op het bord, als de rechtse (met een gekleurde cirkel) aan staat kan de linkermuisknop gebruikt worden voor het tekenen op het bord. De kleur van de cirkel geeft aan met welke kleur getekend kan worden, de kleur kan verandert worden door op deze knop te klikken.

### Knoppen voor cirkels en pijlen 

![Knoppen voor cirkels en pijlen]({{site.baseurl}}/assets/ddb/screenshots//1.5/anno-buttons.gif){: #fig:anno-buttons width="12%"} Rechts van de blauwe cirkel zijn twee knoppen: een prullenbak, en een oog (al dan niet met een streep erdoor). Door op de prullenbak te klikken worden alle cirkels en pijlen verwijderd. Door op het oog te drukken worden de cirkels en pijlen verborgen (en komt er een streep door het oog). Nogmaals drukken laat de cirkels en pijlen weer zien. Als je een cirkel of pijl gaat tekenen als de cirkels en pijlen verborgen zijn, worden die automatisch weer op 'laten zien' gezet. Zie ook  [Tekenen met de linkermuisknop](#tekenen-met-de-linkermuisknop) en  [Tekenen met de rechtermuisknop](#tekenen-met-de-rechtermuisknop) voor het tekenen van cirkels en pijlen op het bord.

## Knoppen naast het schaakbord: stellingen en zetten

Als de stellingenlijst niet leeg is, verschijnen er rechtsonder ook knoppen om door de stellingen en zetten heen te lopen. Er zijn twee kolommen met knoppen: de linkse kolom is voor het lopen door de stellinglijst, en de rechtse kolom is voor het lopen door de zetten die bij de stelling horen.

### Knoppen voor stellingen 

Voor de linkse kolom zijn er de volgende knoppen (van boven naar onder):

![naar begin]({{site.baseurl}}/assets/ddb/screenshots//1.5/two-up.gif){: #fig:two-up-pos width="6%"} ga naar de eerste stelling,

![een terug]({{site.baseurl}}/assets/ddb/screenshots//1.5/one-up.gif){: #fig:one-up-pos width="6%"} ga een stelling terug,

![reset]({{site.baseurl}}/assets/ddb/screenshots//1.5/reset-position.gif){: #fig:reset-pos width="6%"} ga terug naar de huidige stelling (als je bijv. stukken hebt verplaatst)

![een vooruit]({{site.baseurl}}/assets/ddb/screenshots//1.5/one-down.gif){: #fig:one-down-pos width="6%"} ga naar de volgende stelling,

![naar eind]({{site.baseurl}}/assets/ddb/screenshots//1.5/two-down.gif){: #fig:two-down-pos width="6%"} ga naar de laatste stelling.

Als een andere stelling geselecteerd wordt, worden automatisch alle cirkels en pijlen die getekend waren verwijderd.

### Knoppen voor zetten 

Op dezelfde manier zijn er vijf knoppen voor de zetten, van boven naar onder:

![naar begin]({{site.baseurl}}/assets/ddb/screenshots//1.5/two-up.gif){: #fig:two-up-move width="6%"} ga naar de stelling voor de eerste zet

![een terug]({{site.baseurl}}/assets/ddb/screenshots//1.5/one-up.gif){: #fig:one-up-move width="6%"} ga een zet terug,

![reset]({{site.baseurl}}/assets/ddb/screenshots//1.5/reset-position.gif){: #fig:reset-move width="6%"} ga terug naar de stelling na de huidige zet (als je bijv. stukken hebt verplaatst),

![een vooruit]({{site.baseurl}}/assets/ddb/screenshots//1.5/one-down.gif){: #fig:one-down-move width="6%"} doe de volgende zet,

![naar eind]({{site.baseurl}}/assets/ddb/screenshots//1.5/two-down.gif){: #fig:two-down-move width="6%"} ga naar de stelling na de laatste zet.

Als je een zet uitvoert op het bord (door een stuk te verplaatsen) die 'toevallig' overkomt met de volgende (of vorige) zet in de zettenlijst, dan zal het DigiDemoBord aannemen dat je die zet wilde spelen, en de 'huidige' zet automatisch aanpassen.

## Stellingnaam en zoeken van stellingen en zetten 

Als er stellingen gemaakt of geladen zijn, dan staat de naam van de huidige stelling linksboven in het presentatiescherm. Als er nog geen zet gespeeld is, staat er tussen rechte haken achter de stellingnaam wie er aan zet is ('\[W\]' of '\[Z\]'). Als er een zet gespeeld is, is de laatst gespeelde zet achter de stellingnaam te zien, zie fig. [4](#fig:position-name).

![Figure 4: Stellingnaam linksboven in presentatiescherm]({{site.baseurl}}/assets/ddb/screenshots//1.5/position-name.gif){: #fig:position-name .align-center width="60%"}

Als de stelling handmatig verandert is (zetten handmatig uitgevoerd, of stukken op het bord gezet, of ervan af gehaald), zal de stellingnaam in een lichtere (bruine) kleur worden afgebeeld, om aan te geven dat de stelling niet precies overeenkomt met de stellingnaam en zet. As de handmatige verplaatsing van een stuk overeenkomt met de volgende (of vorige) zet uit de zettenlijst, wordt aangenomen dat deze zet gespeeld is. De zetinformatie wordt dan aangepast, en de stellingnaam blijft zwart.

![Figure 5: Stelling zoeken op naam]({{site.baseurl}}/assets/ddb/screenshots//1.5/position-search.gif){: #fig:position-search .align-center width="60%"}

Voor de stellingnaam staat een vergrootglasknop, zie fig. [4](#fig:position-name). Deze kan gebruikt worden om snel naar een stelling of zet te zoeken. Als je op deze knop klikt, verschijnt er op de plek waar de naam van de stelling stond een tekstinvoervak. Zodra je daar letters typt, verschijnen alle stellingen met een naam die (deels) overeenkomt met de letters die getyped zijn, zie fig. [5](#fig:position-search). Je kan dan een van deze stellingen kiezen door er met de pijltjestoetsen doorheen te gaan, of nog meer letters typen. Daarna kan je met 'Enter' uiteindelijk een stelling kiezen. Daarna zal een nieuwe tekstinvoer verschijnen om ook op zo'n manier een zet te kiezen, zie fig. [6](#fig:move-search).

![Figure 6: Zet zoeken]({{site.baseurl}}/assets/ddb/screenshots//1.5/move-search.gif){: #fig:move-search .align-center width="60%"}

De tekstinvoer vakken (met de lijsten van stellingen/namen die (deels) overeenkomen met wat je typt) werken vergelijkbaar:

-   letters typen (of weghalen): de lijst met stellingen/zetten die overeenkomen wordt aangepast
-   'Enter' als er niets in ingetyped, of een niet bestaande stellingnaam: het zoeken wordt gestopt (en niets geselecteerd)
-   'Enter' als er een bestaande stellingnaam (of zet) in het vak staat: die wordt geselecteerd, en na een stelling kan dan een zet geselecteerd worden,
-   'Esc': het zoeken wordt gestopt, er wordt niets geselecteerd.

Het is mogelijk dat er meerdere stellingen (of zetten) zijn met dezelfde naam. In dat geval zal altijd de *eerste* naam die exact overeenkomt gekozen worden. Het is daarom handig om geen stellingen met dezelfde naam te gebruiken.

# Schaakbord 

## Stukken 

Stukken kunnen van boven of onder het bord op het bord gesleept worden om een opstelling te maken. Slepen gebeurt door de linkermuisknop ingedrukt te houden, terwijl de muis beweegt, of op een touch-screen door te vegen over het bord. Stukken kunnen ook van het bord af gesleept worden om ze van het bord te verwijderen. Verder kunnen stukken verplaatst worden om een stelling aan te passen, of om zetten uit te voeren. Als een stuk gesleept wordt naar een veld waar al een stuk staat, zal het stuk wat er al staat van het bord verdwijnen (alsof het geslagen is).

## Stellingen en zetten 

Voor stellingen en zetten in het DigiDemoBord geldt:

-   het schaakbord kan onmogelijke stellingen laten zien, zoals bijv. een stelling zonder koningen, of met twee witte koningen, of met een witte en zwarte koning naast elkaar, of met pionnen op de 1ste of 8ste rij;
-   stukken kunnen willekeurig verplaatst worden, er wordt niet gekeken of de verplaatsing een goede (legale) zet is;
-   als een stuk verplaatst wordt, en dat zou een bijzondere zet kunnen zijn (rokade / en-passent slaan / promotie), dan zal het schaakbord de complete zet uitvoeren. Bijvoorbeeld bij:
    -   Ke1-g1: als er een toren op h1 staat, zal die dan automatisch naar f1 verplaatst worden (als de velden tussen de koning en de toren leeg zijn)
    -   e7-e8: de pion op e8 wordt automatisch vervangen door een dame (voor minor-promotie kan je een ander stuk naar het promotieveld slepen);
    -   e5-d6: als er op d5 een zwarte pion staat, en op d6 geen stuk, dan zal dit gezien worden als en-passent slaan, en zal de zwarte pion van d5 automatisch weggehaald worden.

## Tekenen op het bord 

Er kan 'getekend' worden op het schaakbord. Velden kunnen gemarkeerd worden met een cirkel, en er kunnen pijlen van een veld naar een ander veld getekend worden. Een voorbeeld hiervan is te zien in fig. [7](#fig:annotaties).

![Figure 7: Annotaties met pijlen en cirkels.]({{site.baseurl}}/assets/ddb/screenshots//annotaties.gif){: #fig:annotaties .align-center width="50%"}

Tekenen op het scherm kan op twee manieren: met de linkermuisknop (en op het touchscreen), of met de rechtermuisknop (werkt niet op touchscreens).

### Tekenen met de linkermuisknop 

Met de linkermuisknop (en door te slepen / klikken op het touchscreen) kan je stukken verplaatsen. Als je pijlen en cirkels wil tekenen, moet je in 'annotatie-modus' zijn. Dit ben je als de de blauwe (of andere kleur) cirkel in de tweede rij van de knoppen (zie ook  [Knoppen voor de muis](#knoppen-voor-de-muis)) naast het bord helder van kleur is. In dat geval is de knop ernaast (met de pion) licht van kleur (vaag). Als de knop met de cirkel licht van kleur (vaag) is, wordt'ie helder als je er een keer op klikt. De kleur van de cirkel geeft de kleur van de te tekenen pijlen en cirkel aan. Als je vaker op de knop met de cirkel klikt, verandert de kleur van de cirkel. Door weer op de knop met de zwarte pion te drukken, zorg je ervoor dat je met de linkermuisknop weer stukken kan verplaatsen.

In annotatie-modus kan je pijlen tekenen door te slepen (van start- naar eindveld), en cirkels teken je door te klikken op een veld.

De kleur van de pijl of cirkel wordt normaal gesproken bepaald door de kleur van de cirkel in de knop op de tweede rij. Daarnaast is er nog een andere manier om in een andere kleur te tekenen. Met de muis gaat dat door de Ctrl, Shift of Alt toets in te drukken tijdens het tekenen (de toets die ingedrukt is op het moment dat de muis niet meer ingedrukt wordt), en op een touchscreen gaat dat door extra vingers op het touchscreen te plaatsen:

-   geen Ctrl/Shift/Alt / geen extra vingers: kleur van de knop met de cirkel
-   Alt ingedrukt / een extra vinger: geel
-   Shift ingedrukt / twee extra vingers: rood
-   Ctrl ingedrukt / drie extra vingers: groen

De extra vingers hoeven niet in de buurt van de annotatie te zijn, maar ze moeten wel tijdens de hele annotatie op het scherm blijven. Als je een van de vingers eerder van het scherm haalt, kan het zijn dat het tekenen van de pijl niet goed gaat.

Het verwijderen van een enkele cirkel of pijl kan gedaan worden door deze opnieuw te tekenen (dus: klikken op een veld met een cirkel zal de cirkel verwijderen, en slepen voor een pijl).

### Tekenen met de rechtermuisknop 

Met de muis kan ook de rechtermuisknop gebruikt worden om te tekenen. Klikken met de rechtermuisknop resulteert in een cirkel op het geklikte veld. Slepen met de rechtermuisknop geeft een pijl van het start- naar het eindveld. Hier geldt hetzelfde systeem voor toetsen en kleuren.

### Acties op alle cirkels en pijlen

Met de twee knoppen naast de blauwe cirkel (zie ook  [Knoppen voor cirkels en pijlen](#knoppen-voor-cirkels-en-pijlen)) naast het bord kan je 1) alle cirkels en pijlen weggooien (prullenbak), of de cirkels en pijlen verbergen (het oog wordt een oog met streep erdoor) of weer laten zien (het oog met een streep erdoor wordt weer een normaal oog). Als de cirkels en pijlen verborgen zijn, zullen ze verschijnen zodra je begint met tekenen van een nieuwe cirkel of pijl.

# DigiDemoBord Editor

Het is mogelijk om via het DigiDemoBord van te voren stellingen en zetten in te voeren en op te slaan, en deze later weer te gebruiken. Hiervoor is het 'Editor' scherm nodig. Je kan naar het 'Editor' scherm gaan via de knop hiervoor in de knoppenbalk onderaan (en terug naar het presentatiescherm met dezelfde knop). Fig. [8](#fig:editor) laat het 'Editor' scherm zien.

![Figure 8: Presentatiescherm met knoppenbalk die verschijnt als je met de muis naar de onderkant van het scherm gaat.]({{site.baseurl}}/assets/ddb/screenshots//1.5/editor-framed.gif){: #fig:editor .align-center width="80%"}

Het 'Editor' scherm bevat het presentatiescherm. Links daarvan staan twee lijsten, een met alle (geladen) stellingen, en daarnaast een lijst met zetten die hoort bij de geselecteerde stelling. En onder het presentatiescherm met het schaakbord zijn de knoppen en tekstinvoer voor het invoeren van stellingen en zetten. Verder is de balk onderaan het scherm altijd zichtbaar, en die heeft drie extra knoppen aan de linkerkant: een knop om alle stellingen weg te gooien (prullenbak), en knop om een bestand (met stellingen en zetten) in te lezen, en een knop om de huidige stellingen en zettenlijsten op te slaan in een bestand.

## Lijsten met stellingen en zetten 

De lijsten met stellingen en zetten laten zien welke stellingen (en voor de geselecteerde stelling: welke zetten) ingevoerd (of geladen uit een bestand) zijn. Stellingen (en zetten) die in de lijsten staan, kunnen gebruikt worden in het presentatiescherm. Hieronder wordt beschreven hoe stellingen en zetten ingevoerd kunnen worden, hoe ze gewijzigd en verwijderd kunnen worden, en hoe deze kunnen worden opgeslagen in een bestand.

## Stellingen invoeren in de lijst 

Als je stellingen invoert, geef je een schaakstelling een naam. Stellingen die je zo ingevoerd hebt, kan je later weer makkelijk tevoorschijn halen. Je kan deze stellingen (samen met de zetten die bij de stelling horen) ook opslaan in een eigen bestand. Zo'n bestand is geen PGN bestand, maar een eigen formaat. (De reden hiervoor is dat PGN bestanden eigenlijk alleen legale stellingen en zetten kunnen bevatten, terwijl je soms voor een instructie een stelling wilt gebruiken die niet legaal is, bijv. een stelling zonder koningen.)

![Figure 9: Stellingen invoeren]({{site.baseurl}}/assets/ddb/screenshots//1.5/make-positions.gif){: #fig:make-positions .align-center width="50%"}

Voor het invoeren van een stelling in het DigiDemoBord zet je eerst de juiste stelling op het bord. Dat kan door de stukken op het bord te slepen, of door een van de tekstinvoeren rechtsonder te gebruiken, zie fig. [9](#fig:make-positions). Deze geven de mogelijkheid om:

-   een FEN in te voeren (na Enter wordt de stelling van de FEN op het bord gezet)
-   de zwarte stukken in te voeren (bijv. Ta8 a7 b6 Te8 Kg8 f7 g7 h6), na Enter worden deze stukken aan het bord toegevoegd
-   de witte stukken in te voeren (gaat net zoals de zwarte stukken)

![Figure 10: Stellingen toevoegen]({{site.baseurl}}/assets/ddb/screenshots//1.5/edit-positions.gif){: #fig:edit-positions .align-center width="50%"}

Vervolgens kan je een naam voor de stelling invoeren (midden onder het schaakbord, zie fig. [10](#fig:edit-positions)), en met Enter (of de knop met de '+') de stelling met naam toevoegen aan de lijst met stellingen. De stelling op het schaakbord wordt dan met de ingevulde naam toegevoegd aan de stellingenlijst links in het scherm.

Als je handig bent met het toetsenbord, kan je op de volgende manier makkelijk stellingen toevoegen:

-   type een 'E' een leeg bord maken, en vervolgens staat de cursor in het vak voor zwarte stukken;
-   type zwarte stukken in, en gebruik 'Enter', dan worden de zwarte stukken op het bord gezet, en wordt de cursor in het vak voor de witte stukken gezet;
-   type witte stukken in, en gebruik 'Enter', dan worden de witte stukken op het bord gezet, en wordt de cursor in het vak voor de stellingnaam gezet;
-   type de stellingnaam, en gebruik 'Enter' om de stelling met de naam toe te voegen;
-   de 'record' button gaat automatisch aan, en je kan de zetten spelen;
-   als je klaar bent met de zetten, kan je weer bovenaan beginnen.

Het is mogelijk om meerdere stellingen met dezelfde naam toe te voegen, maar dit kan problemen geven in andere onderdelen van het DigiDemoBord (bijv. het snel zoeken op naam), dus het is beter dit niet te doen.

## Zettten invoeren in de lijst 

Als je een stelling met naam hebt toegevoegd, kan je ook zetten toevoegen. Dat gaat door de zetten uit te voeren op het bord. Hiervoor moet de 'record' knop (onder de stelling naam invoer, zie fig. [10](#fig:edit-positions)) aan staan. Als je een stelling met naam hebt toegevoegd, zal de 'record' knop automatisch aan gaan. Elke zet die je dan uitvoert op het schaakbord zal toegevoegd worden aan de zettenlijst die bij de stelling hoort. Je kan de 'record' knop ook zelf handmatig aan- of uitzetten. En op deze manier kan je ook later nog zetten aan een stelling toevoegen.

![Figure 11: Ingevoerde stellingen en zetten]({{site.baseurl}}/assets/ddb/screenshots//1.5/position-list.gif){: #fig:position-list .align-center width="50%"}

Er wordt niet gecontroleerd of de uitgevoerde zetten legale schaakzetten zijn. Een paard als een toren verplaatsen is mogelijk, en zo'n zet kan ingevoerd, en later weer gespeeld worden. Het toevoegen of verwijderen van stukken wordt niet als een zet gezien.

In een paar gevallen zal een bijzondere zet herkend worden:

-   rokade: als de koning twee posities naar links of rechts opschuift, en de betreffende toren staat op zijn plaats, dan zal een rokade worden uitgevoerd (als de tussenliggende velden leeg zijn).
-   en passent slaan: als een pion op de vijfde rij schuin gaat naar een leeg veld, en de tegenpartij heeft een pion op de vijfde rij achter de nieuwe positie van de pion staan, dan wordt een en passent slag aangenomen, en wordt de pion van de tegenstander automatisch van het bord verwijderd.
-   promotie: als een pion aan de overkant aankomt, zal de pion automatisch door een dame vervangen worden. Als je een minor-promotie wil, moet je daarna het betreffende stuk gelijk na deze zet op de dame slepen, dan wordt de zet aangepast en gezien als een minor-promotie.

Je kan in de zettenlijst gelijk de aangepaste zet zien.

## Stellingen of zetten verwijderen uit de lijst

Je kan stellingen (of zetten) verwijderen door deze te selecteren (er op klikken) in de stellingen lijst (zie fig. [11](#fig:position-list)), en dan te verwijderen door op de delete knop ('Del') te drukken. Stellingen kunnen geselecteerd worden door er op te klikken. Meerdere stellingen kunnen geselecteerd worden door Ctrl of Shift te gebruiken: met Ctrl selecteer je een extra stelling , of haal je een al geselecteerde stelling uit de selectie. Met Shift selecteer je alle stellingen tussen de vorige geklikte en de stelling die je nu klikt. Zetten verwijderen gaat helemaal op dezelfde manier.

Als je zetten verwijdert, kan het zijn dat de volgende zetten niet meer kloppen. Deze zetten kunnen dan niet uitgevoerd worden. Deze 'illegale' of onmogelijke zetten zullen niet automatisch verwijderd worden.

## Stellingen veranderen in de lijst

Je kan de naam van een stelling, of de stelling op het bord van een al eerder ingevoerde stelling, veranderen. Dat gaat door eerst de stelling te selecteren, dan de nieuwe naam in te vullen bij Stellingnaam, of de stelling op het bord aan te passen, en dan Shift+Enter te gebruiken. Dit zal de huidige geselecteerde stelling de nieuwe naam (als ingevoerd) geven, en de bijbehorende stelling aanpassen.

## Opslaan van stellingen en zetten

![Bestand opslaan]({{site.baseurl}}/assets/ddb/screenshots//1.5/editor-save-file.gif){: #fig:editor-save-file width="12%"} Als stellingen en bijbehorende zetten aan de stellingenlijst (en zettenlijst) toegevoegd zijn, kunnen ze naar een bestand worden geschreven. Dit gaat met de knop "Sla bestand op (download)" onderaan links in de knoppenbalk. Hiermee worden de stellingen en zetten in een bestand op de computer gezet, om later weer te laden en gebruiken. Het bestand krijgt de naam 'stellingen-DATUM-TIJD.txt' (of een vergelijkbare naam). opgeslagen. Hierbij is DATUM en TIJD de huidige datum en het tijdstip van opslaan. Door deze naam is de kans klein dat je een bestaand bestand overschrijft, en je kan later terugzien wanneer je het bestand gemaakt hebt. Als je een bestand geladen hebt met een DATUM en TIJD in de bestandsnaam zoals hierboven, dat wordt bij het opslaan de DATUM en TIJD in de bestandsnaam vervangen door de huidige datum en tijd. Het is verstandig om dit bestand uiteindelijk een goede naam te geven Het is goed om hierbij de extensie (.txt) van de bestandsnaam niet aan te passen. Het is ook mogelijk je browser zo in te stellen dat de browser je de gelegenheid geeft de bestandsnaam (en map waar het bestand wordt opgslagen) aan te passen, zie eind van dit document.

## Laden van stellingen en zetten

![Bestand laden]({{site.baseurl}}/assets/ddb/screenshots//1.5/editor-open-file.gif){: #fig:editor-open-file width="12%"} Stellingen en zetten die opgeslagen zijn in een bestand, kunnen weer geladen worden via de knop 'Open bestand' (helemaal links onder in de knoppenbbalk). Na klikken op deze knop wordt (bij Windows) een Verkenner geopend. Blader naar het juiste bestand (wat eerder opgeslagen is), en selecteer/open dat bestand.

Bij het laden wordt nu nog niet veel gecontroleerd (bijvoorbeeld of het bestand echt stellingen heeft). Het laden van een verkeerd bestand kan ervoor zorgen dat het DigiDemoBord niet meer werkt. Opnieuw opstarten van het DigiDemoBord (bijv. met F5) is dan de oplossing.

Naast het laden van bestanden die eerder met het DigiDemoBord gemaakt zijn, kan je ook PGN bestanden inlezen. Het laden van een groot PGN bestand kan lang duren, maar zodra de eerste partij geladen is, kan de partij al afgespeeld worden.

## Verwijderen van stellingen en zetten

![Stellingen verwijderen]({{site.baseurl}}/assets/ddb/screenshots//1.5/editor-delete.gif){: #fig:editor-delete width="12%"} Als je de geladen stellingen weer wilt verwijderen, kan je klikken op de knop met de vuilnisbak (linksonder in het knoppenbalk) Dit verwijdert alle geladen stellingen.

# Gebruik je Browser! 

Het DigiDemoBord werkt via je browser. Dat betekent dat ook allerlei opties van de browser gebruikt kunnen worden. De volgende opties zijn bijvoorbeeld beschikbaar voor Firefox:

-   Ctrl - : zoom in
-   Ctrl + : zoom out
-   Ctrl 0 : reset zoom
-   F11 : wisselen tussen volledige scherm en een window (het DigiDemoBord heeft ook een knop hiervoor, deze is *niet* te gebruiken met F11: als je met F11 naar het volledige scherm gaat, dan moet je met 'Esc' weer terug; als je de DigiDemoBord knop gebruikt, moet je ook de DigiDemoBord knop gebruiken om weer terug te gaan)
-   F5 : opnieuw opstarten van het DigiDemoBord (de stellingen en zettenlijst worden dan ook leeggemaakt!)

De zoom opties hebben alleen effect voor de knoppen en tekst e.d., het schaakbord zelf zal altijd zo groot mogelijk blijven.

Voor het opslaan van de zetten in een bestand wordt de 'download' functie van de browser gebruikt. Normaal gesproken worden het bestand dan in een standaard map ('Download') opgeslagen. In de instellingen van je browser kan je aangeven dat je wil dat de browser ook vraagt om de map waar het bestand moet worden opgeslagen. (In Firefox: selecteer het menu (de drie horizontale streepjes rechtsboven), kies 'Opties' uit het menu, en zorg dan dat, bij Bestanden en Toepassingen 'Vraag altijd waar bestanden op te slaan' aangevinkt is.) Als je browser dan om een map vraagt, kan je ook gelijk de naam van het bestand aanpassen.

# Handig om te weten

Hieronder volgen wat zaken die goed zijn om te weten, ook als het niet de hele handleiding leest.

-   je kan door het intypen van 'E' in het editorscherm het bord leegmaken, en de cursor in het deel voor zwarte stukken zetten (zie  [Stellingen invoeren in de lijst](#stellingen-invoeren-in-de-lijst)), dit kan handig zijn als je met name het toetsenbord wilt gebruiken voor het invoeren van stellingen;
-   je kan met de rechtermuisknop pijlen en cirkels tekenen (zie  [Tekenen met de rechtermuisknop](#tekenen-met-de-rechtermuisknop))
-   je kan de kleur van de pijlen en cirkels aangeven door de Ctrl, Shift of Alt toets in te drukken tijdens het tekenen (zie  [Tekenen met de linkermuisknop](#tekenen-met-de-linkermuisknop));
-   op een touchscreen kan je de kleur van de pijl of cirkel die je aan het tekenen bent, veranderen door meer vingers op het touchscreen te houden (zie  [Tekenen met de linkermuisknop](#tekenen-met-de-linkermuisknop));
-   je kan een pijl of cirkel weer weghalen door hem nog een keer te tekenen (de kleur is hier niet van belang);
-   je kan PGN bestanden en bestanden aangemaakt met het DigiDemoBord laden;
-   je kan geen PGN bestanden opslaan met het DigiDemoBord.

------------------------------------------------------------------------

# Technische informatie

Onderstaande informatie is met name bedoeld voor ontwikkelaars van de software.

## Bestandsformaat stellingen en zetten

Het bestandsformaat is een tekstbestand met een eenvoudige structuur. De eerste regel bevat een versie-aanduiding (zodat nieuwere versies meer ingewikkelde bestanden kunnen opslaan). Alle volgende regels hebben achtereenvolgens de stellingnaam, de stelling (in FEN formaat; alleen de stelling, niet de overige info) en eventueel de zetten. De stellingnaam en de FEN van de stelling worden gescheiden door een '\|', en de stelling en de zetten worden gescheiden door een '\#'. Zetten worden aangegeven met start- en eindveld, gescheiden door een streepje (-), of x bij een slagzet, en worden voorafgegaan door de letter van het stuk (in het Nederlands!), behalve voor de pion. Rokade is O-O (kort) of O-O-O (lang), hoofdletters voor wit, kleine letters voor zwart. Bij minorpromotie volgt de letter van het nieuwe stuk direct op de zet.

Als je zelf zetten wil toevoegen of wijzigen in dit bestand, volstaat het begin en eindveld met een streepje, bijv. e2-e4 e7-e5 f1-f3.

Een voorbeeldregel uit het bestand is:

> Start \| rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR

En hetzelfde met zetten:

> Start \| rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR \# e2-e4 e7-e5 Pg1-f3 Pb8-c6

Vanwege deze manier van opslaan mag de stellingnaam allerlei letters hebben (zelfs spaties en leestekens), maar geen '\|'. Dit wordt *niet* gecontroleerd!

Lege regels in het bestand, of regels die beginnen met een '\#', worden niet gebruikt. Met een gewone teksteditor kan het bestand eventueel aangepast worden. De huidige versie van het DigiDemoBord gaat er van uit dat het bestand een bestand met zetten is, en controleert nauwelijks of the inhoud van het bestand inderdaad een zettenbestand is. Resultaat van het laden van een bestand wat geen zetten of stellingen bevat, is nu onvoorspelbaar.

## Notatie speciale zetten

De rokade wordt aangegeven met o-o (kort) of o-o-o (lang), in hoofdletters voor wit, en kleine letters voor zwart. En-passent zetten hebben '\_ep' na de zet (bijv. e5xd6\_ep). Bij een promotie wordt de letter van het nieuwe stuk na de zet gezet (bijv. e2-e1T, en vanaf 1.5 e2-e1=T voor een zwarte minor promotie).

## Letters voor stukken

Het DigiDemoBord gebruikt intern de Engelse notatie voor stukken (K = King, Q = Queen, R = Rook, B = Bishop, K = Knight and P = pawn). Het interface en de zetnotatie (in het interface, en ook in het bestand) gebruikt de Nederlandse letters (K = Koning, D = Dame, T = Toren, L = Loper, P = Paard, en niets voor de pion).

## Bekende problemen en to-do lijst

Bekende problemen:

-   Is met name getest op Firefox / Chrome onder Windows, maar nog niet uitgebreid op andere browsers / platforms.
-   Het laden van een grote PGN file kan lang duren.
-   Niet alle functies zijn beschikbaar op alle Android browsers (op mijn mobiel ondersteunt Edge meer functies dan Firefox, bijv. het laden van een bestand).

En op de to-do lijst staat:

-   Testen op meer platforms/browsers.
-   Verbetering interface en functionaliteit?
-   Informatie voor gebruikers (bijv. als er iets mis gaat)
-   Ook cirkels en pijlen opslaan in een bestand?
-   Opslaan van PGN bestanden?
-   Ook tekst laten zien (bijv. commentaar uit PGN bestand)
-   Ook alternatieve zettenreeksen gebruiken (bijv. uit PGN bestand)

# Dankbetuigingen

Velen stellen hun code en gereedschappen gratis ter beschikking aan anderen, daar is dankbaar gebruik van gemaakt. Zonder de onderstaande had DigiDemoBord niet geweest wat het nu is!

Het DigiDemoBord is gebaseerd op de javascript chessboard module van Chris Oakman (chessboard-1.0.0.js van [chessboardjs.com](http://chessboardjs.com)). Aan deze module is de annotatie-code toegevoegd (initieel gebaseerd op een fork van [chessboard-0.3.0 door Raneku](http://github.com/raneku/chessboardjs)). Verder wordt jQuery gebruikt (jQuery-1-12.4.js). Voor het inlezen van PGN files is gebruik gemaakt van de [pgn-parser van mliebelt](http://github.com/mliebelt/pgn-parser), en ook de javascript module [chess.js van jhlywa](https://github.com/jhlywa/chess.js). Voor de icons in het user interface zijn de [feathericons](http://feathericons.com) gebruikt. Voor het maken van een stand-alone versie is [html-inline](http://www.npmjs.com/package/html-inline) gebruikt, een programma om een javascript en andere sources in een html-bestand te stoppen, zodat het html-bestand self-contained wordt.

Voor het maken van de handleiding wordt gebruik gemaakt van [pandoc](http://pandoc.org) (met de [pandoc-crossref](https://github.com/lierdakil/pandoc-crossref) extensie) en de [SingleFile add-on van Firefox](https://github.com/gildas-lormeau/SingleFile).

Voor de [DigiDemoBord website](http://digidemobord.gitlab.io) is het [Minimal Mistakes Jekyll Theme](https://mmistakes.github.io/minimal-mistakes/) van Michael Rose gebruikt, en [Jekyll](http://jekyllrb.com) wordt gebruikt om de website te bouwen.

Zowel de DigiDemoBord website als de code van het DigiDemoBord staan in git repositories die gehost worden door [gitlab](http://gitlab.com).
